#include <stdio.h>
#include <string.h>
#include <nds/memory.h>
#include <nds/arm9/console.h>
#include "menu.h"
#include "bank_sel.h"
#include "inout.h"
/*
static uint8* name4[] = 
{
(uint8*)0x0a00000c,
(uint8*)0x0a000028,
(uint8*)0x0a000044,
(uint8*)0x0a000060,
(uint8*)0x0a00007c,
(uint8*)0x0a000098,
(uint8*)0x0a0000b4,
(uint8*)0x0a0000d0,
};

static uint8* name64[] = 
{
(uint8*)0x0a0000ec,
(uint8*)0x0a000108,
(uint8*)0x0a000124,
(uint8*)0x0a000140,
(uint8*)0x0a00015c,
(uint8*)0x0a000178,
};
*/

//static int offset4[] = {12, 40, 68, 96, 124, 152, 180, 208};
//static int offset64[] = {236, 264, 292, 320, 348, 376};

static void mymemcpy(char* dest, char const* src, int size) 
{
  while(size--) 
    *dest++ = *src++;
}

// 4k bank selection
// returns an int to the address needed to write to
int oneSel(void)
{
    consoleClear();
    consolePrintSet(0,1);
    consolePrintf("         4k save  slots         ");
    consolePrintf("--------------------------------");

    char cache4[8][28]={0}; //cache for the sram id's for 4k banks
    memset(cache4, '\0', sizeof(cache4));
    mymemcpy((char*)cache4, (char*)(SRAM+12), sizeof(cache4));//fill the cache with data from the sram

    for (int n=0; n<8; n++)
    {
        consolePrintSet(0,(n+5));
        consolePrintf("    %s", cache4[n]);
    }
    int choice = 1;
    int result = doMenu( 8, choice);
    if (result == 0){choice=0;}
    consoleClear();
    return choice;
}

// 64k bank selection
// returns an int to the address needed to write to
int twoSel(void)
{
    consoleClear();
    consolePrintSet(0,1);
    consolePrintf("        64k save  slots         ");
    consolePrintf("--------------------------------");

    char cache64[6][28]={0}; //cache for the sram id's for 64k banks
    memset(cache64, '\0', sizeof(cache64));
    mymemcpy((char*)cache64, (char*)(SRAM+236), sizeof(cache64));//fill the cache with data from the sram

    for (int n=0; n<6; n++)
    {
        consolePrintSet(0,(n+5));
        consolePrintf("    %s", cache64[n]);
    }
    int choice = 1;
    int result = doMenu( 6, choice);
    if (result == 0){choice=0;}
    consoleClear();
    return choice;
}
