/*
	see:CARDME.H
*/

#include "cardme.h"

#define CARDME_CR1       (*(vuint16*)0x040001A0) /*fixed*/ 
#define CARDME_EEPDATA   (*(vuint16*)0x040001A2)	 /*fixed*/

#define EepromWaitBusy()   while (CARDME_CR1 & /*BUSY*/0x80); 

void cardmeReadEeprom(u32 address, u8 *data, u32 length, u32 addrtype);
void cardmeWriteEepromT1(u32 address, u8 *apData, u32 aLength, u32 addrtype);
void cardmeWriteEepromT2(u32 address, u8 *apData, u32 aLength, u32 addrtype);
void cardmeWriteEepromT3(u32 address, u8 *apData, u32 aLength, u32 addrtype);


u8 cardmeCMD(u8 cmd,int address) 
{ 
//	int address=i & 1;
	u8 ret;
	int k;
    CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40; 

    CARDME_CR1 = 0xFFFF; 
    CARDME_EEPDATA = cmd;	// 

    EepromWaitBusy(); 

        CARDME_EEPDATA = (address >> 16) & 0xFF; 
        EepromWaitBusy(); 

        CARDME_EEPDATA = (address >> 8) & 0xFF; 
        EepromWaitBusy(); 

    CARDME_EEPDATA = (address) & 0xFF; 
    EepromWaitBusy(); 

	for(k=0;k<256;k++)
	{
        ret = CARDME_EEPDATA; 
        if(ret!=0xFF)break;
	    EepromWaitBusy(); 
	}
    CARDME_CR1 = /*MODE*/0x40; 
    return ret;
} 


u8 cardmeReadID(int i) 
{ 
	int address=i & 1;
	u8 ret;
	int k;
    CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40; 

    CARDME_CR1 = 0xFFFF; 
    CARDME_EEPDATA = 0xAB;	// READ ID

    EepromWaitBusy(); 

        CARDME_EEPDATA = (address >> 16) & 0xFF; 
        EepromWaitBusy(); 

        CARDME_EEPDATA = (address >> 8) & 0xFF; 
        EepromWaitBusy(); 

    CARDME_EEPDATA = (address) & 0xFF; 
    EepromWaitBusy(); 

	for(k=0;k<16;k++)
	{
        ret = CARDME_EEPDATA; 
        if(ret!=0xFF)break;
	    EepromWaitBusy(); 
	}
    CARDME_CR1 = /*MODE*/0x40; 
    return ret;
} 



int cardmeGetType(void)
{
	u8 ret;
		WAIT_CR &= ~0x0880;	// DS Card access ARM9:bit11=0   GBA Cart access ARM9:bit7=0
	// 05h Xe[^XWX^
	ret=cardmeCMD(0x05,0);
	if(ret == 0xFF)return -1;
	if(ret >> 4 == 0xF)return 1;
	ret=cardmeCMD(0x9F,0);
	if(ret != 0xFF)return 3;
	return 2;
	
}

int cardmeGetType_old(void)
{
#define HEADSZ (16)
#define TESTSZ (256)
//#define OFS (256-HEADSZ/2)
#define OFS (0)
	u8 testbuf0[TESTSZ+1];
	u8 testbuf1[TESTSZ+1];
	u8 testbufFF[TESTSZ+1];
	int t;
	int lt=0;

		WAIT_CR &= ~0x0880;	// DS Card access ARM9:bit11=0   GBA Cart access ARM9:bit7=0

		memset(testbufFF,0xFF,TESTSZ);

		//	TYPE 1,2,3ŃeXgăf[^ł傫قɂ	
		for(t=1;t<=3;t++)
		{

			//Ô߃NA(Ȃ)
			memset(testbuf0,0x00,TESTSZ);
			memset(testbuf1,0xFF,TESTSZ);


			cardmeReadEeprom(OFS+0,testbuf0,HEADSZ,t);
			cardmeReadEeprom(OFS+0,&testbuf1[0],HEADSZ/2,t);
			cardmeReadEeprom(OFS+HEADSZ/2,&testbuf1[HEADSZ/2],HEADSZ/2,t);

			if(memcmp(testbuf0,testbuf1,HEADSZ)==0)	//	v
			{
				if(memcmp(testbuf0,testbufFF,HEADSZ)==0)continue;	//SFF
				
				lt=t;
			}
		}



		return lt;
}

int cardmeSize(int tp)
{
	if(-1 <= tp && tp <= 3)
	{
		//        -1    0    1    2   3
		int eepsz[5]={ 0,8192, 512,8192,256*1024};
		tp++;
		return eepsz[tp];
	}
	return 0;
}


//////////////////////////////////////////////////////////////////////
void cardmeReadEeprom(u32 address, u8 *data, u32 length, u32 addrtype) 
{ 
    CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40; 
//    CARDME_CR1 = 0xFFFF; 
    CARDME_EEPDATA = 0x03 | ((addrtype == 1) ? address>>8<<3 : 0);
    EepromWaitBusy(); 

    if (addrtype == 3) 
    { 
        CARDME_EEPDATA = (address >> 16) & 0xFF; 
        EepromWaitBusy(); 
    } 
    if (addrtype >= 2) 
    { 
        CARDME_EEPDATA = (address >> 8) & 0xFF; 
        EepromWaitBusy(); 
    } 
    CARDME_EEPDATA = (address) & 0xFF; 
    EepromWaitBusy(); 

    while (length > 0) 
    { 
        CARDME_EEPDATA = 0; 
        EepromWaitBusy(); 
        *data++ = CARDME_EEPDATA; 
        length--; 
    } 
        EepromWaitBusy(); 
    CARDME_CR1 = /*MODE*/0x40; 
} 
//////////////////////////////////////////////////////////////////////


void cardmeWriteEeprom(u32 address, u8 *apData, u32 aLength, u32 addrtype)
{

	switch(addrtype)
	{
		case 1:
				cardmeWriteEepromT1(address,apData,aLength,addrtype);
				return;
		case 2:
				cardmeWriteEepromT2(address,apData,aLength,addrtype);
				return;
		case 3:
				cardmeWriteEepromT3(address,apData,aLength,addrtype);
				return;
	}

}


#define T1BLOCKSZ (16)
//  TYPE1 4kbit EEPROM
void cardmeWriteEepromT1(u32 address, u8 *apData, u32 aLength, u32 addrtype)
{
	int i;
	u32 last=address+aLength;

	while (address < last)
	{


		// set WEL (Write Enable Latch)
		CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40;
		CARDME_EEPDATA = 0x06; 
        EepromWaitBusy();

		CARDME_CR1 = /*MODE*/0x40;

		// program maximum of 16 bytes
		CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40;
		//	WRITE COMMAND 0x02 + A8 << 3
		CARDME_EEPDATA = 0x02 | (address & BIT(8)) >> (8-3) ; 
        EepromWaitBusy();
		CARDME_EEPDATA = address & 0xFF; 
        EepromWaitBusy();


		for (i = 0; address < last && i < T1BLOCKSZ; i++, address++) 
        { 
            CARDME_EEPDATA = *apData; 
            EepromWaitBusy(); 
            apData++;
        }

		CARDME_CR1 = /*MODE*/0x40;

		// wait programming to finish
		CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40;
		CARDME_EEPDATA = 0x05; 
        EepromWaitBusy();

		do 
        { 
            CARDME_EEPDATA = 0; 
            EepromWaitBusy(); 
        } while (CARDME_EEPDATA & 0x01);	// WIP (Write In Progress) ?
        EepromWaitBusy(); 
		CARDME_CR1 = /*MODE*/0x40;

	}

}



//  TYPE2 64kbit EEPROM
void cardmeWriteEepromT2(u32 address, u8 *apData, u32 aLength, u32 addrtype)
{
	int i;
	u32 last=address+aLength;

	while (address < last)
	{


		// set WEL (Write Enable Latch)
		CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40;
		CARDME_EEPDATA = 0x06; 
        EepromWaitBusy();

		CARDME_CR1 = /*MODE*/0x40;

		// program maximum of 32 bytes
		CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40;
		CARDME_EEPDATA = 0x02; 
        EepromWaitBusy();
        CARDME_EEPDATA = address >> 8; 
        EepromWaitBusy(); 
		CARDME_EEPDATA = address & 0xFF; 
        EepromWaitBusy();


		for (i = 0; address < last && i < 32; i++, address++) 
        { 
            CARDME_EEPDATA = *apData; 
            EepromWaitBusy(); 
            apData++;
        }

		CARDME_CR1 = /*MODE*/0x40;

		// wait programming to finish
		CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40;
		CARDME_EEPDATA = 0x05; 
        EepromWaitBusy();

		do 
        { 
            CARDME_EEPDATA = 0; 
            EepromWaitBusy(); 
        } while (CARDME_EEPDATA & 0x01);	// WIP (Write In Progress) ?
        EepromWaitBusy(); 
		CARDME_CR1 = /*MODE*/0x40;

	}

}


#define T3BLOCKSZ (256)
//  TYPE3 2Mbit FLASH MEMORY
void cardmeWriteEepromT3(u32 address, u8 *apData, u32 aLength, u32 addrtype)
{
	int i;
	u32 last=address+aLength;

	while (address < last)
	{


		// set WEL (Write Enable Latch)
		CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40;
		CARDME_EEPDATA = 0x06; 
        EepromWaitBusy();

		CARDME_CR1 = /*MODE*/0x40;

		// program maximum of 32 bytes
		CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40;
		CARDME_EEPDATA = 0x02; 
        EepromWaitBusy();
        CARDME_EEPDATA = (address >> 16) & 0xFF; 
        EepromWaitBusy(); 
        CARDME_EEPDATA = (address >> 8) & 0xFF; 
        EepromWaitBusy(); 
		CARDME_EEPDATA = address & 0xFF; 
        EepromWaitBusy();


		for (i = 0; address < last && i < T3BLOCKSZ; i++, address++) 
        { 
            CARDME_EEPDATA = *apData; 
            EepromWaitBusy(); 
            apData++;
        }

		CARDME_CR1 = /*MODE*/0x40;

		// wait programming to finish
		CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40;
		CARDME_EEPDATA = 0x05; 
        EepromWaitBusy();

		do 
        { 
            CARDME_EEPDATA = 0; 
            EepromWaitBusy(); 
        } while (CARDME_EEPDATA & 0x01);	// WIP (Write In Progress) ?
        EepromWaitBusy(); 
		CARDME_CR1 = /*MODE*/0x40;

	}

}

//	Chip Erase  : clear FLASH MEMORY (TYPE 3 ONLY)
//	COMMAND 0xC7
int cardmeChipErase(void)
{
	{


		// set WEL (Write Enable Latch)
		CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40;
		CARDME_EEPDATA = 0x06; 
        EepromWaitBusy();

		CARDME_CR1 = /*MODE*/0x40;

		// Chip Erase 0xC7
		CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40;
		CARDME_EEPDATA = 0xC7; 
        EepromWaitBusy();

		CARDME_CR1 = /*MODE*/0x40;

		// wait programming to finish
		CARDME_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40;
		CARDME_EEPDATA = 0x05; 
        EepromWaitBusy();

		do 
        { 
            CARDME_EEPDATA = 0; 
            EepromWaitBusy(); 
/*
            if(CARDME_EEPDATA & BIT(5)!=0)
            {
            	return -1;
            }
*/
        } while (CARDME_EEPDATA & 0x01);	// WIP (Write In Progress) ?
        EepromWaitBusy(); 
		CARDME_CR1 = /*MODE*/0x40;

	}
	return 0;
}

//////////////////////////////////////////////////////////////////////
